/*******************************************************************
*
*	Name:         Sam Leachman
*	Date:         5/10/2008
*	Final Project
*
*	 Simultaneously performs the functions of PSXMixer and DancePads
*   from my midterm project. However, it also sends the notes played
*   to a remote computer with the start button.
*
*    Make sure to change "sniffle.local" to your hosting machine,
*   adjust port if necessary (both here and in player file), and
*   ensure that tempi in all three files are identical.
*
*******************************************************************/

// Checks to make sure controllers are present.
Hid js;
HidMsg msg;
if(!js.openJoystick(0)) {
    me.exit();
}
<<< "Stay Cool!!" >>>;

// Constants
80 => int iTempo;
(60.0/iTempo)::second => dur dQuarter;
4 * dQuarter => dur dMeasure;

// First array holds "pitch"; second array holds machine time notes
// are played.
int aiHits[48];
time atTimes[48];

// Plays sounds as buttons are pressed. Starts recording input when
// user presses start.
while (true) {
    js => now;
    while(js.recv(msg)) {
        <<< msg.which >>>;
        if(msg.isButtonDown() && msg.which == 8) {            
            acceptInput();
        }
        else if(msg.axisPosition == 1 && msg.which == 1){
            spork~ playNote(22);
        }
        else if((msg.axisPosition == 1) && (msg.which == 0) ){
            spork~ playNote(11);
        }
        else if((msg.axisPosition == -1) && (msg.which == 1) ){
            spork~ playNote(10);
        }
        else if((msg.axisPosition == -1) && (msg.which == 0) ){
            spork~ playNote(23);
        }
        else if((msg.axisPosition == 1) && (msg.which == 5) ){
            spork~ playNote(26);
        }
        else if((msg.axisPosition == 1) && (msg.which == 4) ){
            spork~ playNote(25);
        }
        else if((msg.axisPosition == -1) && (msg.which == 5) ){
            spork~ playNote(24);
        }
        else if((msg.axisPosition == -1) && (msg.which == 4) ){
            spork~ playNote(27);
        }
        else if(msg.isButtonDown() && msg.which != 21) {
            spork~ playNote(msg.which);
        }
    }
}

// Adds notes to the arrays until start is pressed again, then sends
// score to player.
fun void acceptInput(){
    <<< "Accepting Input" >>>;
    0 => int iNoteNumber;   
    
    while (true) {
        js => now;
        while(js.recv(msg)) {
            if(msg.isButtonDown() && msg.which == 8) {
                sendScore(iNoteNumber);
            }
            else if(msg.isButtonDown() && msg.which == 9) {
                for (int i; i < 100; i++) {
                    Machine.remove(i);
                }
                Machine.add("player");
                Machine.add("controller");
            }            
            else if((msg.axisPosition == 1) && (msg.which == 1) ){
                22 => aiHits[iNoteNumber];
                spork~ playNote(22);
                now => atTimes[iNoteNumber];
                iNoteNumber++;
                <<< "DownP1." >>>;
            }
            else if((msg.axisPosition == 1) && (msg.which == 0) ){
                11 => aiHits[iNoteNumber];
                spork~ playNote(11);
                now => atTimes[iNoteNumber];
                iNoteNumber++;
                <<< "RightP1." >>>; 
            }
            else if((msg.axisPosition == -1) && (msg.which == 1) ){
                10 => aiHits[iNoteNumber];
                spork~ playNote(10);
                now => atTimes[iNoteNumber];
                iNoteNumber++;
                <<< "UpP1." >>>;   
            }
            else if((msg.axisPosition == -1) && (msg.which == 0) ){
                23 => aiHits[iNoteNumber];
                spork~ playNote(23);
                now => atTimes[iNoteNumber];
                iNoteNumber++;
                <<< "LeftP1." >>>;   
            }
            else if((msg.axisPosition == 1) && (msg.which == 5) ){
                26 => aiHits[iNoteNumber];
                spork~ playNote(26);
                now => atTimes[iNoteNumber];
                iNoteNumber++;
                <<< "DownP2." >>>;   
            }
            else if((msg.axisPosition == 1) && (msg.which == 4) ){
                25 => aiHits[iNoteNumber];
                spork~ playNote(25);
                now => atTimes[iNoteNumber];
                iNoteNumber++;
                <<< "RightP2." >>>;   
            }
            else if((msg.axisPosition == -1) && (msg.which == 5) ){
                24 => aiHits[iNoteNumber];
                spork~ playNote(24);
                now => atTimes[iNoteNumber];
                iNoteNumber++;
                <<< "UpP2." >>>;   
            }
            else if((msg.axisPosition == -1) && (msg.which == 4) ){
                27 => aiHits[iNoteNumber];
                spork~ playNote(27);
                now => atTimes[iNoteNumber];
                iNoteNumber++;
                <<< "LeftP2." >>>;   
            }
            else if(msg.isButtonDown() && msg.which != 21) {
                msg.which => aiHits[iNoteNumber];
                spork~ playNote(msg.which);
                now => atTimes[iNoteNumber];
                iNoteNumber++;
                <<< msg.which >>>;
            }
        }
    }
}

// Tells the player how many notes to expect, then sends their
// pitches and times over. Starts the shred over again.
fun void sendScore(int iNumNotes) {
    OscSend signalPlayer;
    signalPlayer.setHost("sniffle.local", 7777);
    signalPlayer.startMsg("num, i");
    signalPlayer.addInt(iNumNotes);
    for (int i; i < iNumNotes; i++) {
        signalPlayer.startMsg("beat, i, f");
        signalPlayer.addInt(aiHits[i]);
        signalPlayer.addFloat((atTimes[i]/(1::samp)));
    }
    Machine.add("controller");
    me.exit();
}

// Opens up the appropriate sound file, plays it, and quits. See
// readme for button mappings.
fun void playNote(int iSoundNum) {
    string strSound[28];
    "./data/LT0DA.WAV" => strSound[0];
    "./data/HHCD6.wav" => strSound[1];
    "./data/ddm-ht.wav" => strSound[2];
    "./data/ddm-lt.wav" => strSound[3];
    "null" => strSound[4];
    "./data/ddm-ch.wav" => strSound[5];
    "./data/MA.WAV" => strSound[6];
    "./data/HHODA.WAV" => strSound[7];
    "null" => strSound[8];
    "null" => strSound[9];
    "./data/ST0T3SA.WAV" => strSound[10];
    "./data/RIM127.WAV" => strSound[11];
    "./data/LT0DA.WAV" => strSound[12];
    "./data/LT3DA.WAV" => strSound[13];
    "./data/LT7DA.WAV" => strSound[14];
    "./data/LTADA.WAV" => strSound[15];
    "null" => strSound[16];
    "null" => strSound[17];
    "null" => strSound[18];
    "null" => strSound[19];
    "./data/LT3DA.WAV" => strSound[20];
    "null" => strSound[21];
    "./data/CSHD4.WAV" => strSound[22];
    "./data/HANDCLP1.WAV" => strSound[23];
    "./data/Bb.wav" => strSound[24];
    "./data/G.wav" => strSound[25];
    "./data/D.wav" => strSound[26];
    "./data/C.wav" => strSound[27];
    
    SndBuf buffy => dac;
    buffy.read(strSound[iSoundNum]);
    8000::samp => now;
    buffy =< dac;
}