/*******************************************************************
*
*	Name:         Sam Leachman
*	Date:         5/10/2008
*	Final Project
*
*	 Corrects input loop and plays it ad infinitum.
*
*******************************************************************/

// Constants
80 => int iTempo;
(60.0/iTempo)::second => dur dQuarter;
4 * dQuarter => dur dMeasure;
dQuarter / 24. => dur dErr;
dQuarter / 4. => dur d16;
dQuarter / 3. => dur d12;
d16 / 2. => dur d32;

// Pitch and time matrices are recreated with data from controller
int aiHits[48];
float afTimes[48];
int iNoteNumber;

OscRecv drumcue;
drumcue.port(7777);
drumcue.listen();
drumcue.event("num, i") @=> OscEvent numnotescue;
drumcue.event("beat, i, f") @=> OscEvent drumplay;
numnotescue => now;
numnotescue.nextMsg();
numnotescue.getInt() => iNoteNumber;

for (int i; i < iNoteNumber; i++) {
    drumplay => now;
    drumplay.nextMsg();
    drumplay.getInt() => aiHits[i];
    drumplay.getFloat() => afTimes[i];
}


// An attempt is made to find the intended temporal position
// for each beat.
dur adIntended[iNoteNumber];
afTimes[0] => float fDownbeat;

for (int i; i < iNoteNumber; i++) {
    (afTimes[i] - fDownbeat) * (1::samp) => adIntended[i];
}

//Initial Input
for (int i; i < iNoteNumber; i++) {
    <<< adIntended[i] >>>;
}

// Moves each duration to the nearest sixteenth or quarter-triplet.
for (int i; i < iNoteNumber; i++) {
    if (adIntended[i] > (0::samp - d32) && adIntended[i] < (0::samp + d32)) {
        0::samp => adIntended[i];
    }
    else if(adIntended[i] > (d16 - d32) && adIntended[i] < (d16 + dErr)) {
        d16 => adIntended[i];
    }
    else if(adIntended[i] > (2*d16 - 2.5*dErr) && adIntended[i] < (2*d16 + 2.5*dErr)) {
        2*d16 => adIntended[i];
    }
    else if(adIntended[i] > (3*d16 - dErr) && adIntended[i] < (3*d16 + d32)) {
        3*d16 => adIntended[i];
    }
    else if(adIntended[i] > (4*d16 - d32) && adIntended[i] < (4*d16 + d32)) {
        4*d16 => adIntended[i];
    }
    else if(adIntended[i] > (5*d16 - d32) && adIntended[i] < (5*d16 + dErr)) {
        5*d16 => adIntended[i];
    }
    else if(adIntended[i] > (6*d16 - 2.5*dErr) && adIntended[i] < (6*d16 + 2.5*dErr)) {
        6*d16 => adIntended[i];
    }
    else if(adIntended[i] > (7*d16 - dErr) && adIntended[i] < (7*d16 + d32)) {
        7*d16 => adIntended[i];
    }
    else if(adIntended[i] > (8*d16 - d32) && adIntended[i] < (8*d16 + d32)) {
        8*d16 => adIntended[i];
    }
    else if(adIntended[i] > (9*d16 - d32) && adIntended[i] < (9*d16 + dErr)) {
        9*d16 => adIntended[i];
    }
    else if(adIntended[i] > (10*d16 - 2.5*dErr) && adIntended[i] < (10*d16 + 2.5*dErr)) {
        10*d16 => adIntended[i];
    }
    else if(adIntended[i] > (11*d16 - dErr) && adIntended[i] < (11*d16 + d32)) {
        11*d16 => adIntended[i];
    }
    else if(adIntended[i] > (12*d16 - d32) && adIntended[i] < (12*d16 + d32)) {
        12*d16 => adIntended[i];
    }
    else if(adIntended[i] > (13*d16 - d32) && adIntended[i] < (13*d16 + dErr)) {
        13*d16 => adIntended[i];
    }
    else if(adIntended[i] > (14*d16 - 2.5*dErr) && adIntended[i] < (14*d16 + 2.5*dErr)) {
        14*d16 => adIntended[i];
    }
    else if(adIntended[i] > (15*d16 - dErr) && adIntended[i] < (15*d16 + d32)) {
        15*d16 => adIntended[i];
    }
    else if(adIntended[i] > (16*d16 - d32) && adIntended[i] < (16*d16 + d32)) {
        16*d16 => adIntended[i];
    }
    else if(adIntended[i] > (17*d16 - d32) && adIntended[i] < (17*d16 + dErr)) {
        17*d16 => adIntended[i];
    }
    else if(adIntended[i] > (18*d16 - 2.5*dErr) && adIntended[i] < (18*d16 + 2.5*dErr)) {
        18*d16 => adIntended[i];
    }
    else if(adIntended[i] > (19*d16 - dErr) && adIntended[i] < (19*d16 + d32)) {
        19*d16 => adIntended[i];
    }
    else if(adIntended[i] > (20*d16 - d32) && adIntended[i] < (20*d16 + d32)) {
        20*d16 => adIntended[i];
    }
    else if(adIntended[i] > (21*d16 - d32) && adIntended[i] < (21*d16 + dErr)) {
        21*d16 => adIntended[i];
    }
    else if(adIntended[i] > (22*d16 - 2.5*dErr) && adIntended[i] < (22*d16 + 2.5*dErr)) {
        22*d16 => adIntended[i];
    }
    else if(adIntended[i] > (23*d16 - dErr) && adIntended[i] < (23*d16 + d32)) {
        23*d16 => adIntended[i];
    }
    else if(adIntended[i] > (24*d16 - d32) && adIntended[i] < (24*d16 + d32)) {
        24*d16 => adIntended[i];
    }
    else if(adIntended[i] > (25*d16 - d32) && adIntended[i] < (25*d16 + dErr)) {
        25*d16 => adIntended[i];
    }
    else if(adIntended[i] > (26*d16 - 2.5*dErr) && adIntended[i] < (26*d16 + 2.5*dErr)) {
        26*d16 => adIntended[i];
    }
    else if(adIntended[i] > (27*d16 - dErr) && adIntended[i] < (27*d16 + d32)) {
        27*d16 => adIntended[i];
    }
    else if(adIntended[i] > (28*d16 - d32) && adIntended[i] < (28*d16 + d32)) {
        28*d16 => adIntended[i];
    }
    else if(adIntended[i] > (29*d16 - d32) && adIntended[i] < (29*d16 + dErr)) {
        29*d16 => adIntended[i];
    }
    else if(adIntended[i] > (30*d16 - 2.5*dErr) && adIntended[i] < (30*d16 + 2.5*dErr)) {
        30*d16 => adIntended[i];
    }
    else if(adIntended[i] > (31*d16 - dErr) && adIntended[i] < (31*d16 + d32)) {
        31*d16 => adIntended[i];
    }
    else if(adIntended[i] > (32*d16 - d32) && adIntended[i] < (32*d16 + d32)) {
        32*d16 => adIntended[i];
    }
    else if(adIntended[i] > (1*d12 - dErr) && adIntended[i] < (1*d12 + dErr)) {
        1*d12 => adIntended[i];
    }
    else if(adIntended[i] > (2*d12 - dErr) && adIntended[i] < (2*d12 + dErr)) {
        2*d12 => adIntended[i];
    }
    else if(adIntended[i] > (4*d12 - dErr) && adIntended[i] < (4*d12 + dErr)) {
        4*d12 => adIntended[i];
    }
    else if(adIntended[i] > (5*d12 - dErr) && adIntended[i] < (5*d12 + dErr)) {
        5*d12 => adIntended[i];
    }
    else if(adIntended[i] > (7*d12 - dErr) && adIntended[i] < (7*d12 + dErr)) {
        7*d12 => adIntended[i];
    }
    else if(adIntended[i] > (8*d12 - dErr) && adIntended[i] < (8*d12 + dErr)) {
        8*d12 => adIntended[i];
    }
    else if(adIntended[i] > (10*d12 - dErr) && adIntended[i] < (10*d12 + dErr)) {
        10*d12 => adIntended[i];
    }
    else if(adIntended[i] > (11*d12 - dErr) && adIntended[i] < (11*d12 + dErr)) {
        11*d12 => adIntended[i];
    }
    else if(adIntended[i] > (13*d12 - dErr) && adIntended[i] < (13*d12 + dErr)) {
        13*d12 => adIntended[i];
    }
    else if(adIntended[i] > (14*d12 - dErr) && adIntended[i] < (14*d12 + dErr)) {
        14*d12 => adIntended[i];
    }
    else if(adIntended[i] > (16*d12 - dErr) && adIntended[i] < (16*d12 + dErr)) {
        16*d12 => adIntended[i];
    }
    else if(adIntended[i] > (17*d12 - dErr) && adIntended[i] < (17*d12 + dErr)) {
        17*d12 => adIntended[i];
    }
    else if(adIntended[i] > (19*d12 - dErr) && adIntended[i] < (19*d12 + dErr)) {
        19*d12 => adIntended[i];
    }
    else if(adIntended[i] > (20*d12 - dErr) && adIntended[i] < (20*d12 + dErr)) {
        20*d12 => adIntended[i];
    }
    else if(adIntended[i] > (22*d12 - dErr) && adIntended[i] < (22*d12 + dErr)) {
        22*d12 => adIntended[i];
    }
    else if(adIntended[i] > (23*d12 - dErr) && adIntended[i] < (23*d12 + dErr)) {
        23*d12 => adIntended[i];
    }
}

// Plays each corrected note in a loop.
Machine.add("player");
while(true) {
    (dMeasure - (now % dMeasure)) => now;
    for (int i; i < iNoteNumber - 1; i++) {
        spork~ playNote(aiHits[i]);
        adIntended[i + 1] - adIntended[i] => now;        
    }
    spork~ playNote(aiHits[iNoteNumber - 1]);
}

// Opens up the appropriate sound file, plays it, and quits. See
// readme for button mappings.
fun void playNote(int iSoundNum) {
    string strSound[28];
    "./data/LT0DA.WAV" => strSound[0];
    "./data/HHCD6.wav" => strSound[1];
    "./data/ddm-ht.wav" => strSound[2];
    "./data/ddm-lt.wav" => strSound[3];
    "null" => strSound[4];
    "./data/ddm-ch.wav" => strSound[5];
    "./data/MA.WAV" => strSound[6];
    "./data/HHODA.WAV" => strSound[7];
    "null" => strSound[8];
    "null" => strSound[9];
    "./data/ST0T3SA.WAV" => strSound[10];
    "./data/RIM127.WAV" => strSound[11];
    "./data/LT0DA.WAV" => strSound[12];
    "./data/LT3DA.WAV" => strSound[13];
    "./data/LT7DA.WAV" => strSound[14];
    "./data/LTADA.WAV" => strSound[15];
    "null" => strSound[16];
    "null" => strSound[17];
    "null" => strSound[18];
    "null" => strSound[19];
    "./data/LT3DA.WAV" => strSound[20];
    "./data/LT7DA.WAV" => strSound[21];
    "./data/CSHD4.WAV" => strSound[22];
    "./data/HANDCLP1.WAV" => strSound[23];
    "./data/Bb.wav" => strSound[24];
    "./data/G.wav" => strSound[25];
    "./data/D.wav" => strSound[26];
    "./data/C.wav" => strSound[27];
    
    SndBuf buffy => dac;
    buffy.read(strSound[iSoundNum]);
    8000::samp => now;
    buffy =< dac;
}